
Raid = {}

function Raid.AssignNewMissionTo(raid, previousType, previousResult)
	local mission

	
	local CurrentCrystal
	for x, c in pairs(fy_Crystal.GetAll()) do
		local distance = Vector3.Distance(c.position, raid.position)
		if distance < 20 then
			CurrentCrystal = c
			break
		end
	end

    if raid.role == 1 then -- if it's a skirmish raid, ignore everything else and send it to a player crystal
        
        crystals = fy_Crystal.GetAllOfFaction(Faction.defaultAllied)
        crystal = crystals[ math.random(#crystals)]
        mission = RaidMission.New(RaidMission.Type.Exterminate, crystal.position)
        Registry.skirmishRaids = Registry.skirmishRaids + 1

    else
	    if CurrentCrystal ~= nil and ((previousType == 1 and previousResult == 0) 
		    or Registry.defendRaidsCount < Registry.defendRaidRequired
			    or Registry.attackRaidsCount >= Registry.attackRaidLimit) then
		    mission = RaidMission.New(RaidMission.Type.Occupy, CurrentCrystal.position, 60)
			    Registry.defendRaidsCount = Registry.defendRaidsCount + 1
			    print("******New defend mission, now "..tostring(Registry.defendRaidsCount))
	    else
		    local crystals

		    if not Registry.timers.timeBeforeHostility.Check() then

			    crystals = fy_Crystal.GetAllOfFactions({Faction.defaultNeutral, raid.faction})
		
		    elseif Registry.timers.maxTimeBetweenAttacks.Check() then
			
			    crystals = fy_Crystal.GetAllOfFaction(Faction.defaultAllied)

		    else
			    crystals = fy_Crystal.GetAll()

		    end

		    crystal = crystals[ math.random(#crystals)]

		    if crystal.faction == Faction.defaultAllied then
			    print("**** Raiding player crystal at " ..tostring(crystal))
			    Registry.timers.maxTimeBetweenAttacks.Reset()
		    end

		    mission = RaidMission.New(RaidMission.Type.Exterminate, crystal.position)
		    Registry.attackRaidsCount = Registry.attackRaidsCount + 1
		    print("******New exterminate mission, at "..tostring(crystal))

		
	    end
    end
	raid.GiveMission(mission)

end

--Result 0 = Accomplished
--Result 1 = GroupRouted
--Result 2 = GroupAnnihilated
--Result 3 = Canceled
--Result 4 = TimeOver
--Type 0 = MoveTo
--Type 1 = Exterminate
--Type 2 = Occupy
--Type 3 = Sack
--Type 4 = Capture
function MissionEnded(oldMission, result)

	if oldMission ~= nil then
		if oldMission.raid.faction == Faction.FindByName("Corrupted") then
			if result == 0 or  result == 1 or  result == 2 or  result == 4 then --If accomplished, routed, annihilated or timeover
				if oldMission ~= nil then
					if oldMission.raid.role == 1 then
						Registry.skirmishRaids = Math.Max(Registry.skirmishRaids - 1,0)
					else
						if oldMission.type == 2 then --if was occupying
							Registry.defendRaidsCount = Math.Max(Registry.defendRaidsCount - 1,0)
						elseif oldMission.type == 1 then --if was exterminating
							Registry.attackRaidsCount = Math.Max(Registry.attackRaidsCount - 1,0)
						end
					end
				end
		--		if result == 2 then --If Annihilated
		--			Registry.raidBudget = Registry.raidBudget + 1
		--		else
				if result != 2 then --If not Annihilated
					Raid.AssignNewMissionTo(oldMission.raid, oldMission.type, result)
				end
			end
		end
	end
end
Hooks.Connect(RaidMission.hk_OnMissionEnded, MissionEnded)

function Raid.SpawnAt(raid, position)
	for x, pair in pairs(RaidPresets[raid.presetLevel][raid.presetRaid]) do
		for y = 1, pair[1] do
			local newguy = Spawner.Around(pair[2].Ref, position, raid.faction, nil)
			raid.AssignLabor(newguy)
		end
	end
end

function Raid.SpawnOnCrystal(role)

	local allSpawns = fy_Crystal.GetAllOfFaction(Faction.FindByName("Corrupted"))
	while true do

		local candidate = table.remove(allSpawns, math.random(#allSpawns))
		if candidate ~= nil and candidate.IsContested() == false then

            if role == 1 then
                local preset, plevel, praid = RaidPresets.GetAtLevel(1)
				local raid = fy_RaidProject.New( Faction.FindByName("Corrupted"), candidate.position)
				raid.presetLevel = plevel
                raid.presetRaid = praid
                raid.role = role

                Raid.AssignNewMissionTo(raid, nil, nil)
				Raid.SpawnAt(raid, candidate.position)

            else
			    local preset, plevel, praid = RaidPresets.GetUnderBudget(1000)
			    if preset ~= nil then

				    local raid = fy_RaidProject.New( Faction.FindByName("Corrupted"), candidate.position)
					raid.presetLevel = plevel
                    raid.presetRaid = praid
                    raid.role = role

                    Raid.AssignNewMissionTo(raid, nil, nil)
				    Raid.SpawnAt(raid, candidate.position)
				    Registry.raidBudget = Registry.raidBudget - 1

			    end
            end
			return

		end

		if #allSpawns <= 0 then return end
	end

end
