
RaidPresets = 
{
	Level1 = 
	{
		Raid1 = 
		{
			{2, Characters.Minitron},
			{1, Characters.Corruptron}
		},
		Raid2 = 
		{
			{3, Characters.Minitron}
		},
		Raid3 = 
		{
			{1, Characters.Minitron},
			{2, Characters.Corruptron}
		},
		Raid4 = 
		{
			{2, Characters.Corruptron}
		},
		Raid5 = 
		{
			{2, Characters.Minitron},
			{1, Characters.Corruptron}
		}
	},
    Level2 = 
	{
		Raid1 = 
		{
			{3, Characters.Minitron},
			{2, Characters.Corruptron}
		},
		Raid2 = 
		{
			{7, Characters.Minitron}
		},
		Raid3 = 
		{
			{4, Characters.Minitron},
			{1, Characters.Biftron}
		},
		Raid4 = 
		{
			{4, Characters.Corruptron}
		},
		Raid5 = 
		{
			{4, Characters.Minitron},
			{2, Characters.Corruptron}
		}
	},
	Level3 = 
	{
		Raid1 = 
		{
			{10, Characters.Minitron},
			{3, Characters.Corruptron}
		},
		Raid2 = 
		{
			{14, Characters.Minitron}
		},
		Raid3 = 
		{
			{6, Characters.Minitron},
			{2, Characters.Biftron}
		},
		Raid4 = 
		{
			{6, Characters.Corruptron},
			{1, Characters.Biftron}
		},
		Raid5 = 
		{
			{3, Characters.Minitron},
			{4, Characters.Corruptron},
			{1, Characters.Biftron}
		}
	},
	Level4 = 
	{
		Raid1 = 
		{
			{12, Characters.Minitron},
			{3, Characters.Corruptron},
			{1, Characters.Biftron}
		},
		Raid2 = 
		{
			{5, Characters.Minitron},
			{7, Characters.Corruptron},
			{1, Characters.Biftron}
		},
		Raid3 = 
		{
			{10, Characters.Minitron},
			{3, Characters.Biftron}
		},
		Raid4 = 
		{
			{9, Characters.Corruptron},
			{2, Characters.Biftron}
		},
		Raid5 = 
		{
			{10, Characters.Minitron},
			{5, Characters.Corruptron},
			{1, Characters.Biftron}
		}
	},

    GetAtLevel = function(desiredLevel)
        local affordable = {}
		local affordableName = {}
        local currentLevel
		local levelName

		if desiredLevel == 1 then  currentLevel = RaidPresets.Level1 ; levelName = "Level1"
		elseif desiredLevel == 2 then  currentLevel = RaidPresets.Level2 ; levelName = "Level2"
        elseif desiredLevel == 3 then  currentLevel = RaidPresets.Level3 ; levelName = "Level3"
		else currentLevel = RaidPresets.Level4 ; levelName = "Level4"
		end

		for i, set in pairs(currentLevel) do
			local cost = 0
			for j, pair in pairs(set) do
				cost = cost + (pair[1] * pair[2].Cost)
			end
			if true then
				table.insert(affordable, set)
				table.insert(affordableName, i)
			end
		end
		if #affordable == 0 then
			return nil, nil, nil
		end

		local chosenNumber = math.random(#affordable)
		return affordable[ chosenNumber], levelName, affordableName[ chosenNumber]

    end,

	GetUnderBudget = function(budget)
		local affordable = {}
		local affordableName = {}
		local currentLevel
		local levelName

		if Registry.currentLevel == 1 then  currentLevel = RaidPresets.Level1  ; levelName = "Level1"
		elseif Registry.currentLevel == 2 then  currentLevel = RaidPresets.Level2  ; levelName = "Level2"
        elseif Registry.currentLevel == 3 then  currentLevel = RaidPresets.Level3 ; levelName = "Level3"
		else currentLevel = RaidPresets.Level4 ; levelName = "Level4"
		end

		for i, set in pairs(currentLevel) do
			local cost = 0
			for j, pair in pairs(set) do
				cost = cost + (pair[1] * pair[2].Cost)
			end
			if cost <= budget then
				table.insert(affordable, set)
				table.insert(affordableName, i)
			end
		end
		if #affordable == 0 then
			return nil
		end

		local chosenNumber = math.random(#affordable)
		return affordable[ chosenNumber], levelName, affordableName[ chosenNumber]
	end
}
