define "GAMEMODE"

include "config.lua"
include "ui.lua"

--from is an object, key is a static key, ie: fy_Crystal
local function FindClosestFromKey(from, key)

    local allKeys = key.GetAll()
    local closestDistance = 9999.0
    local closestKey = nil

    for x, mine in pairs(allKeys) do

        local dist = Vector3.Distance(from.position, mine.position)
        if dist < closestDistance then
            closestDistance = dist
            closestKey = mine
        end

    end

    return closestKey

end

function OnBeforeTerrainLoaded()
	TerrainData.SetAtlasColorTypePair(3, 8)
	TerrainData.SetAtlasColorTypePair(4, 8)
	TerrainData.SetAtlasColorTypePair(5, 8)
	
end
Hooks.Connect(hk_OnBeforeTerrainLoaded, OnBeforeTerrainLoaded)

function OnNewLevelReady()

	local crystals = fy_Crystal.GetAll()
	if #crystals == 0 then
		error("No spawnpoints in map")
	else
		for x, crystal in pairs( crystals) do
			if fy_User.localUser.alliedFaction == crystal.faction then
				MainCamera.SetRotation(54.0, 45.0, 0.0)
				MainCamera.LookAt(crystal.position)
			end
		end
	end

	DisplayDisclaimer()
end
Hooks.Connect(hk_OnNewLevelReady, OnNewLevelReady)

function OnLevelReady()
	UISetup()
	Sound.Play("Sandbox")
	if sv_Settings.canDigGround == false then
		Rules.SetDigRules( {Diggables.Crust, Diggables.Artificial})
		Rules.SetExplosionRules( {Diggables.Crust, Diggables.Artificial})
		Rules.SetAllowedTasks( {TaskType.Construction, TaskType.Lumber, TaskType.Cleaning, TaskType.Repair} ) --TaskType.Tunnel, TaskType.Landscape, TaskType.Quarry
		Mergeback.allowMergeback = false
	end

	Rules.canCaptureCapturables = true
	Rules.canSpawnMilitaryUnits = true
	Rules.playerRelations = sv_Settings.playerRelations

	fy_BricktronFirefly.__Factory.refundValue = sv_Settings.refundBricktron
	fy_MinitronFirefly.__Factory.refundValue = sv_Settings.refundMinitron
	fy_CorruptronFirefly.__Factory.refundValue = sv_Settings.refundCorruptron
	fy_BiftronFirefly.__Factory.refundValue = sv_Settings.refundBiftron
	Rules.forcePlayerFirefliesToPlayerCrystal = sv_Settings.forcePlayerFirefliesToPlayerCrystal

	fy_BricktronFirefly.timeToAbsorption = sv_Settings.timeToFireflyAbsorption

	local crystals = fy_Crystal.GetAll()
	if #crystals == 0 then
		error("No spawnpoints in map")
	else
		for x, crystal in pairs( crystals) do
			Hooks.Connect(crystal.hk_OnFactionChanged, OnCrystalFactionChanged)
		end
	end

end
Hooks.Connect(hk_OnLevelReady, OnLevelReady)
