local playerTabs = {}

function AddPlayerTab(user)
	local tab = LUI.PlayerTab.New()
	tab.SetIcon(user.alliedFaction.factionIcon)
	tab.Name.Text = user.name
	tab.Name.Color = user.alliedFaction.factionColor
	tab.Status.Text = ""
	LUI.Scoreboard.AddInPlayerList(tab)
	table.insert(playerTabs, tab)
end

function OnCrystalFactionChanged(old, new)
	-- 1 arg == OnExplosion<LuaDriver>, 2 arg == OnFactionChanged<LuaDriver, old Faction>
	
	if (IsServer()) then
		UpdatePopCap(old,fy_Crystal.CountOfFaction(old))
		UpdatePopCap(new,fy_Crystal.CountOfFaction(new))
	end
		
	if (fy_User.localUser.alliedFaction  ~= Faction.spectator )then
		local total = fy_Crystal.Count()
		local allied = fy_Crystal.CountOfFaction(Faction.defaultAllied)
		local neutral = fy_Crystal.CountOfFaction(Faction.defaultNeutral)
		
		local gameoverMessage = "dialog_gameover";

			if allied == 0 then
				Picking.DeselectAll()
				Faction.AllVisible(true)
				Rules.SetAllowedTasks( {} )
				fy_User.localUser.alliedFaction = Faction.spectator
					if IsMultiplayer() then
						DisplayDialog("dialog_gameover_title", gameoverMessage, {"button_return_titlescreen", "button_continue_spectator"}, {function() Hooks.Invoke(hk_CallEndGame) end, function() end})
					else
						DisplayOkDialog("dialog_gameover_title", gameoverMessage, "button_return_titlescreen", function() Hooks.Invoke(hk_CallEndGame) end)
					end
				elseif allied + neutral >= total then
					Picking.DeselectAll()
					Faction.AllVisible(true)
					Rules.SetAllowedTasks( {} )
					DisplayOkDialog("dialog_victory_title", "dialog_victory", "button_return_titlescreen", function() Hooks.Invoke(hk_CallEndGame) end)
			end
	end
end

function DisplayDisclaimer()
  DisplayOkDialog("Conquest", "conquest_desc", "button_ready", function() if not IsMultiplayer() then StartTimers() end end)
  end

function LaborCreated(labor)

    if labor.faction == Faction.defaultAllied then

      GMBricktrons.OnAddLabor(labor)

    end
  end


function LaborDeleted(labor)

    if labor.faction == Faction.defaultAllied then

      GMBricktrons.OnRemoveLabor(labor)
    end
  end

function UISetup()

	if IsMultiplayer() then
      for x, crystal in pairs(fy_Crystal.GetAll()) do
		if crystal.faction ~= Faction.defaultNeutral then
			if fy_User.localUser.alliedFaction == crystal.faction then
			  MainCamera.LookAt(crystal.position)
			end
			if crystal.faction.owner ~= nill then
			  beacon = fy_FlagBeacon.New(crystal.faction, crystal.position)
			  beacon.beaconIcon = crystal.faction.factionIcon
			  beacon.displayName = crystal.faction.owner.name
			end
		end
      end

      for x, user in pairs(fy_User.GetAll()) do
			if user.alliedFaction.HasOwner() then
				AddPlayerTab(user)
			end
      end

    end

      GMBricktrons = LUI.Player.New()
	  LUI.Scoreboard.Add(GMBricktrons)	  

      for x, crystal in pairs(fy_Crystal.GetAll()) do

        local crystalStatus = LUI.CrystalStatus.New()
        crystalStatus.Crystal = crystal
        LUI.Scoreboard.AddInGrid(crystalStatus)

      end
      if IsBuildDebug() then
	      SpawnButton = LUI.Button.New()
	      SpawnButton.Text.Text = "NYCB"
	      SpawnButton.ButtonAction = function()
	        local raid = fy_RaidProject.New(CorruptedFaction, Vector3.zero)
	        raid.name = "New York City Boys"
			raid.role = 0
	        local spawns = fy_EnemySpawnPoint.GetAll()
	        local spawnPosition = MainCamera.targetLocation
	        local specialPreset = {
	          { 1, Characters.Biftron },
	          { 2, Characters.Minitron },
	          { 2, Characters.Corruptron }
	        }
	        for x, pair in pairs(specialPreset) do

	          for y = 1, pair[1] do

	            local newguy = pair[2].Ref.New(CorruptedFaction, Random.VoxelAround(spawnPosition))
	            raid.AssignLabor(newguy)

	          end
	        end

	        raid.GiveMission(RaidMission.New(RaidMission.Type.Exterminate, fy_Crystal.GetFirstOfFaction(Faction.defaultAllied).position))
	      end
	      LUI.Scoreboard.AddInGrid(SpawnButton)


	      GMDebugText = LUI.DebugTextbox.New()
	      GMDebugText.Text.Text = ":)"
	      LUI.Scoreboard.Add(GMDebugText)
	  end

    Hooks.Connect(hk_OnLaborCreated, LaborCreated)
    Hooks.Connect(hk_OnLaborDeleted, LaborDeleted)

end