define "GAMEMODE"

include "config.lua"
include "invasion_ui.lua"
include "invasion.lua"
include "RaidPresets.lua"

function OnBeforeTerrainLoaded()
    TerrainData.SetAtlasColorTypePair(3, 8)
    TerrainData.SetAtlasColorTypePair(4, 8)
    TerrainData.SetAtlasColorTypePair(5, 8)
end
Hooks.Connect(hk_OnBeforeTerrainLoaded, OnBeforeTerrainLoaded)

function OnLevelReady()
    UISetup()
    Sound.Play("Survival")
    fy_MinitronFirefly.__Factory.refundValue = sv_Settings.refundMinitron
    fy_CorruptronFirefly.__Factory.refundValue = sv_Settings.refundCorruptron
    fy_BiftronFirefly.__Factory.refundValue = sv_Settings.refundBiftron
    Hooks.Connect(fy_Crystal.GetFirst().hk_OnExplosion, PlayerLost)

	fy_BricktronFirefly.timeToAbsorption = sv_Settings.timeToFireflyAbsorption

	if IsMultiplayer() then
	local crystals = fy_Crystal.GetAll()
        for x, crystal in pairs(crystals) do
			if fy_User.localUser.alliedFaction == crystal.faction then
				MainCamera.SetRotation(54.0, 45.0, 0.0)
				MainCamera.LookAt(crystal.position)
			end
			beacon = fy_FlagBeacon.New(crystal.faction, crystal.position)
			beacon.beaconIcon = crystal.faction.factionIcon
			beacon.displayName = crystal.faction.owner.name
		end
    end
end
Hooks.Connect(hk_OnLevelReady, OnLevelReady)

function OnNewLevelReady()
    DisplayDisclaimer()
    sv_SaveParams.waveTimer = Timer.New(sv_Settings.waveDuration + sv_Settings.firstWaveDurationBonus)
    sv_SaveParams.waveBudget = sv_Settings.firstWaveBudget
    local crystals = fy_Crystal.GetAll()
    for x, crystal in pairs(crystals) do
        if fy_User.localUser.alliedFaction == crystal.faction then
			MainCamera.SetRotation(54.0, 45.0, 0.0)
            MainCamera.LookAt(crystal.position)
            Hooks.Connect(crystal.hk_OnExplosion, PlayerLost)
        end

        if IsMultiplayer() then
            -- AddPlayerTab(crystal.faction)
            beacon = fy_FlagBeacon.New(crystal.faction, crystal.position)
            beacon.beaconIcon = crystal.faction.factionIcon
            beacon.displayName = crystal.faction.owner.name
        end

    end
end
Hooks.Connect(hk_OnNewLevelReady, OnNewLevelReady)

function OnServerMessage(table)
     sv_SaveParams.waveTimer = Timer.New(100)
	 sv_SaveParams.waveTimer = table[0]

end
Hooks.Connect(hk_OnServerMessage, OnServerMessage)