include "config.lua"
include "main.lua"
include "player.lua"

local topIslandOffsets = {
	Vector3.New(3.0, 25.0, 3.0),
	Vector3.New(-5.0, 50.0, -5.0),
	Vector3.New(5.0, 75.0, -10.0),
}

local spawnLocations = {
	Vector3.zero,
	Vector3.New(250.0, 0.0, 0.0),
	Vector3.New(250.0, 0.0, 250.0),
	Vector3.New(0.0, 0.0, 250.0),
}

local players = {}
local ruleKeep = {
	TotalPlayers = 0,
	PlayersDoneSetup = 0,
	GameStarted = false
}

cor_LevelReadyTrack = nil
function OnLevelReady()
	cor_LevelReadyTrack = coroutine.create(LevelReadyTrack)
end
Hooks.Connect(hk_OnLevelReady, OnLevelReady)

function LevelReadyTrack()
	local users = fy_User.GetAll()
	ruleKeep.TotalPlayers = fy_User.Count()
	local i = 1
	for x, user in pairs(users) do
		local ply = Player(user)
		ply.IslandLocation = spawnLocations[i]
		ply.CurrentLevel = 0
		
		LoadMapAdditive("Info/Lua/Gamemodes/RTTT/Islands/Base", ply.IslandLocation)
		WaitForHook(hk_OnAdditiveMapLoaded)
		spawnPoints = Markers.GetGroup("Player Starting Point")
		spawnPoint = spawnPoints[i]
		Factory.NetworkInstantiate(AssetKey.New("ObjetsDynamiques","Crystal"), ply.faction, nil, spawnPoint.position)
		for ii = 1, sv_Settings.startingBuilders do
			Factory.NetworkInstantiate(AssetKey.New("Test","Bricktron"), ply.faction, nil, Random.VoxelAround(spawnPoint.position))
		end
		ply.setup_stockpiles = 0
		players[i] = ply
		i = i + 1
	end
	Hooks.Invoke(nhk_OnHostLoaded, {})
end

function Update()
	if ruleKeep.GameStarted == false then
		if cor_LevelReadyTrack ~= nil and coroutine.status(cor_LevelReadyTrack) ~= "dead" then
			coroutine.resume(cor_LevelReadyTrack)
		end
	
	else
		for x, ply in pairs(players) do
			if ply.GameTrack ~= nil and coroutine.status(ply.GameTrack) ~= "dead" then
				coroutine.resume(ply.GameTrack, ply)
			end
		end
	end
end
Hooks.Connect(hk_Update, Update)

local function GameTrack(ply)
	ply.CurrentLevel = 1
	
	while ply.CurrentLevel <= 3 do
		LoadMapAdditive("Info/Lua/Gamemodes/RTTT/Islands/ControlP", ply.IslandLocation + topIslandOffsets[ply.CurrentLevel])
		WaitForHook(hk_OnAdditiveMapLoaded)
		local controlPoint = fy_CircleZone.GetLast()
		controlPoint.SetRadius(1.0)
		controlPoint.Appear()
		WaitForCircle(3.0, controlPoint)
		WaitForSeconds(1.0)
		Destroy(controlPoint)
		WaitForNextFrame()
		
		ply.CurrentLevel = ply.CurrentLevel + 1
	end

end

function OnFactoryInstantiated(assetKey, object)
	local goodPly
	if object ~= nil then
		if assetKey == AssetKey.New("ObjetsDynamiques","Palette") then
			for x, ply in pairs(players) do
				if ply.faction == object.faction then
					ply.setup_stockpiles = ply.setup_stockpiles + 1 
					goodPly = ply
					break
				end
			end
		end
	end
	if goodPly ~= nil then
		if goodPly.setup_stockpiles >= 4 then
			ruleKeep.PlayersDoneSetup = ruleKeep.PlayersDoneSetup + 1
			if ruleKeep.TotalPlayers == ruleKeep.PlayersDoneSetup then
				Hooks.Invoke(nhk_OnHostMessage, {"StartGame", {}})
				for x, ply in pairs(players) do
					ply.GameTrack = coroutine.create(GameTrack)
				end
				ruleKeep.GameStarted = true
			end
		end
	end
end
Hooks.Connect(hk_OnFactoryInstantiated, OnFactoryInstantiated)

function WaitForCircle(time, circle)
	WaitForCondition(function()
		if false then
			local timer = Timer.New(time)
			while false do
				coroutine.yield()
				circle.SetProgress(timer.PercentDone())
				if timer.Check() then
					circle.Flash()
					circle.Disappear()
					return true
				end
			end
		else
			circle.SetProgress(0.0)
			return false
		end
	end)
end