define "GAMEMODE"
include "config.lua"
include	"ui.lua"

function OnLevelReady()

	if IsMultiplayer() then

		local crystals = fy_Crystal.GetAll()
		if #crystals == 0 then
			error("No spawnpoints in map")
		else
			for x, crystal in pairs( crystals) do
				if fy_User.localUser.alliedFaction == crystal.faction then
					MainCamera.SetRotation(54.0, 45.0, 0.0)
					MainCamera.LookAt(crystal.position)
				end

			end

            for x, user in pairs(fy_User.GetAll()) do
				if user.alliedFaction.HasOwner() then
					AddPlayerTab(user)
				end
            end
		end
	end
	Sound.Play("Sandbox")
	Rules.playerRelations = sv_Settings.playerRelations
end
Hooks.Connect(hk_OnLevelReady, OnLevelReady)

function OnNewLevelReady()
	--Cleaning the map of unwanted objects
	

	local crystals = fy_Crystal.GetAll()
	if #crystals == 0 then
		error("No spawnpoints in map")
	else
		for x, crystal in pairs( crystals) do
			if fy_User.localUser.alliedFaction == crystal.faction then
				MainCamera.SetRotation(54.0, 45.0, 0.0)
				MainCamera.LookAt(crystal.position)
			end
		end
	end
	if IsMultiplayer() then
		DisplayOkDialog("Multiplayer Sandbox", "sandbox_multiplayer_description", 
					"button_ready", 
					function() end)
	else
		DisplayOkDialog("Sandbox", "sandbox_description", 
					"button_ready", 
					function() end)
	end
end
Hooks.Connect(hk_OnNewLevelReady, OnNewLevelReady)
