function Act1()

	Setup()
	
	local acknowledged = false
	DisplayOkDialog("str_tutorial_welcome", 
						"str_tutorial_basicskills",
						"str_tutorial_letsgo", 
						function() acknowledged = true end)
	WaitForCondition(function() return acknowledged end)
	Sound.Play("Tutorial_Music")
	WaitForSeconds(1)
	
	local label = TooltipBuilder.New()
		.Target(_actors.worker1)
		.Offset( Vector3.New(0.0, 1.0, 0.0))
		.Text("str_tutorial_thisisabricktron")
		.AsDynamic().Make()
	local zone = fy_CircleZone.New(Faction.defaultAllied, Vector3.zero)
	--[
	WaitForNextFrame()
	label.Show()
	WaitForSeconds(2.5)
	label.Hide()
	WaitForSeconds(0.5)

	--Select bricktron
	SetLabel(label, nil, "str_tutorial_selectbricktron", 
					nil, GetIcon(IconKeys.Tutorial_LMB).Image64)
	WaitForCondition(function() return _actors.worker1.isSelected end)
	
	--He's selected
	SetLabel(label,"str_tutorial_verynice", "str_tutorial_bricktronselected", nil, nil)
	WaitForSeconds(2)
	label.Hide();
	WaitForSeconds(0.5)

	--Move bricktron
	ResetCircle(zone, Markers.GetTagged("circle_move_cam").position, 1.0)
	label.Target(zone)
	SetLabel(label, nil, "str_tutorial_movebricktron", nil, GetIcon(IconKeys.Tutorial_RMB).Image64)
	WaitForCircleCondition(1.5, zone, 
		function() return Physics.CheckCollision(zone, _actors.worker1) end)
	WaitForSeconds(0.5)

	--He moved in the circle
	SetLabel(label,"str_tutorial_great", "str_tutorial_camera_controlling", nil, nil)
	WaitForSeconds(3)
	label.Hide()
	WaitForSeconds(0.5)

	--Move the camera with the bricktron
	MainCamera.canMove = true
	ResetCircle(zone, nil, 2.0)
	SetLabel(label,"str_tutorial_camera_titlemoving","str_tutorial _camera_move", 
					GetIcon(IconKeys.Tutorial_KB_WASD).Image64, nil)
	WaitForCircleCondition(2, zone, 
		function() return Physics.ColliderContainsPoint(zone, MainCamera.targetLocation) end)

	--Let's try rotating now
	MainCamera.canMove = false
	SetLabel(label,"str_tutorial_congrats", "str_tutorial_camera_rotate", nil, nil)
	WaitForSeconds(3)
	label.Hide()
	WaitForSeconds(0.5)
	
	--Align cam with the circle
	MainCamera.canRotate = true
	ResetCircle(zone, Markers.GetTagged("circle_camcheck1").position, 0.5)
	local miniLabel = TooltipBuilder.New()
		.Target(zone)
		.Offset( Vector3.New(0.0, 1.0, 0.0))
		.Text("str_tutorial_camera_rotateintocircle")
		.AsDynamic().Make()
	miniLabel.Show()
	label.Target(_actors.worker1)
	SetLabel(label, nil, "str_tutorial_camera_howtorotate", nil, nil)
	WaitForCircleCondition(1.5, zone, 
		function() return Physics.SphereCastFor(zone) end)
	Destroy(miniLabel)
		
	--Align cam with the other circle
	ResetCircle(zone, Markers.GetTagged("circle_camcheck2").position, 0.5)
	label.Target(zone)
	SetLabel(label, "str_tutorial_verynice", "str_tutorial_camera_pointintocircle", nil, nil)
	WaitForCircleCondition(1, zone, 
		function() return Physics.SphereCastFor(zone) end)

	--GJ you know how to rotate
	SetLabel(label, "str_tutorial_excellent", "str_tutorial_camera_youknowit", nil, nil)
	WaitForSeconds(2)
	label.Hide()
	WaitForSeconds(0.5)

	--Go to Act 2
	--]]
	MainCamera.canMove = true
	MainCamera.canRotate = true
	local door = Markers.GetTagged("door_act1to2")
	door.locked = false
	door.Open()
	ResetCircle(zone, Markers.GetTagged("circle_toAct2").position, 2)
	label.Target(zone)
	SetLabel(label, nil, "str_tutorial_progresstonextarea", nil, nil)
	WaitForCircleCondition(1, zone, 
		function() return Physics.ColliderContainsPoint(zone, MainCamera.targetLocation) and Physics.CheckCollision(zone, _actors.worker1) end)

	--end
	door.Close()
	door.locked = true
	WaitForSeconds(0.5)
	Destroy(label);
	Destroy(zone);
	include "BasicTutorial/Act2.lua"
end
cor_tutorial = coroutine.create(Act1)

function Setup()
	--Setting spawn
	
	local spawnpoint = Markers.GetGroup("Player Starting Point")[1]
	_actors.worker1 = fy_Bricktron.New(Faction.defaultAllied, spawnpoint.position)

	--Setting time
	Skybox.dayTime = 10
	Skybox.dayPause = true

	--Setting camera
	
	MainCamera.SetZoom(20.0)
	MainCamera.SetRotation(54.0, 45.0, 0.0)
	MainCamera.LookAt(spawnpoint.position)
	MainCamera.canMove = false
	MainCamera.canRotate = false
	MainCamera.canElevate = false
	MainCamera.canZoom = false
	MainCamera.hugTerrain = false;

	--Setting camera trap
	--_actors.rulezone = fy_RuleZone.New(Faction.defaultAllied, _actors.crystal.position);
	--_actors.rulezone.scale = Vector3.New(15.0, 3.0, 15.0)
	--_actors.rulezone.SetTrapCamera(true)
	--_actors.camera_trap = rulezone
	--UISetup()

	fy_Door.__All.Close()

	Rules.SetDigRules({})
	Rules.SetExplosionRules({})
	Rules.SetAllowedTasks({})
	Rules.canDeleteTask = false
	Mergeback.allowMergeback = false
end