
function Act2()
	--Let's learn picking up
	local label = TooltipBuilder.New()
		.Target(_actors.worker1)
		.Offset( Vector3.New(0.0, 1.0, 0.0))
		.Title("str_tutorial_pickingup_title")
		.Text("str_tutorial_pickupobject")
		.AsDynamic().Make()
	local zone = fy_CircleZone.New(Faction.defaultAllied, Vector3.zero)
	MainCamera.canZoom = true
	
	--[
	label.Show()
	WaitForSeconds(4)
	label.Hide()
	WaitForSeconds(0.5)

	--Spawn log and ask to pick it up
	local log = fy_DoubleLog.New(Faction.defaultAllied, Markers.GetTagged("spawn_log").position)
	label.Target(log)
	SetLabel(label, "str_tutorial_pickingup_title", "str_tutorial_howtopickupobject", nil, nil)
	WaitForCondition(function() return _actors.worker1.RecepteurCarries(log) end)

	--You have picked up the log.
	label.Target(_actors.worker1)
	SetLabel(label, "str_tutorial_verynice", "str_tutorial_pickeduplog", nil, nil)
	WaitForSeconds(2)
	label.Hide()
	WaitForSeconds(0.5)

	--Let's learn to drop objects
	SetLabel(label, "str_tutorial_droppingobj", "str_tutorial _radialmenuintro", nil, nil)
	WaitForSeconds(5)
	label.Hide()
	WaitForSeconds(0.5)

	--Drop the log in the circle
	ResetCircle(zone, Markers.GetTagged("circle_drop_log").position, 2)
	label.Target(zone)
	SetLabel(label, "str_tutorial_droppinglogtitle", "str_tutorial_dropload", nil, nil)
	WaitForCircleCondition(1, zone, 
		function() return Physics.CheckCollision(zone, log) end)

	--You have dropped the log in the right spot!
	SetLabel(label, "str_tutorial_great", "str_tutorial_droppedload", nil, nil)
	WaitForSeconds(3)
	label.Hide()
	WaitForSeconds(0.5)

	--Drop the log into the stockpile instead
	local stockpile = Markers.GetTagged("stockpile_logs")
	ResetCircle(zone, stockpile.position + Vector3.New(0.0, 0.5, 0.0), 2)
	SetLabel(label, "str_tutorial_logtostockpiletitle", "str_tutorial_logtostockpile", nil, nil)
	WaitForCircleCondition(1, zone, 
		function() return stockpile.RecepteurCarries(log) end)

	--Let's fill the stockpile with logs
	SetLabel(label, nil, "str_tutorial_fillstockpile", nil, nil)
	WaitForSeconds(4)
	label.Hide()
	WaitForSeconds(0.5)

	--Cut the tree
	ResetCircle(zone, Markers.GetTagged("tree1").position, 1.5)
	SetLabel(label, nil, "str_tutorial_cutrees", nil, nil)
	WaitForCircleCondition(0.5, zone, 
		function() return not TreePresentAt(zone.position) end)
	label.Hide()
	WaitForSeconds(1)

	--Put them in the stockpile
	ResetCircle(zone, stockpile.position + Vector3.New(0.0, 0.5, 0.0), 2)
	zone.rotation = Quaternion.EulerXYZ(0.0, 270.0, 0.0)
	SetLabel(label, "str_tutorial_good", "The tree is now cut and you got 3 logs from it.\n\n<color=#ffc000ff>- Pick up the logs and put them down in the stockpile.</color>", nil, nil)
	WaitForCondition(function() 
		local prop = stockpile.RecepteurProportionFilled()
		zone.SetProgress(prop)
		return prop >= 0.5
	end)
	-- Two more
	SetLabel(label, nil, "str_tutorial_twomorelogs", nil, nil)
	WaitForCondition(function() 
		local prop = stockpile.RecepteurProportionFilled()
		zone.SetProgress(prop)
		return prop >= 0.75
	end)
	-- One more
	SetLabel(label, nil, "str_tutorial_onemorelog", nil, nil)
	WaitForCondition(function() 
		local prop = stockpile.RecepteurProportionFilled()
		zone.SetProgress(prop)
		return prop >= 0.9
	end)
	zone.SetProgress(1.0)
	WaitForSeconds(0.5)
	zone.Flash()
	zone.Disappear()

	--Excellent, stockpile filed
	SetLabel(label, "str_tutorial_excellent", "str_tutorial_filledstockpile", nil, nil)
	WaitForSeconds(3)
	label.Hide()
	WaitForSeconds(0.5)

	--Go to act 3
	--]]
	local door = Markers.GetTagged("door_act2to3")
	door.locked = false
	door.Open()
	ResetCircle(zone, Markers.GetTagged("circle_toAct3").position, 2)
	SetLabel(label, nil, "str_tutorial_movenextzone", nil, nil)
	WaitForCircleCondition(1, zone, 
		function() return Physics.ColliderContainsPoint(zone, MainCamera.targetLocation) and Physics.CheckCollision(zone, _actors.worker1) end)

	--end
	door.Close()
	door.locked = true
	WaitForSeconds(0.5)
	Destroy(label);
	Destroy(zone);
	include "BasicTutorial/Act3.lua"

end
cor_tutorial = coroutine.create(Act2)
