
function Act3()
	--Let's learn complex task
	local label = TooltipBuilder.New()
		.Target(_actors.worker1)
		.Offset( Vector3.New(0.0, 1.0, 0.0))
		.Title("str_tutorial_complextasks_title")
		.Text("str_tutorial_complextasks")
		.AsDynamic().Make()
	local zone = fy_CircleZone.New(Faction.defaultAllied, Vector3.zero)
	--[
	label.Target(_actors.worker1)
	label.Show()
	WaitForSeconds(4)
	label.Hide()
	WaitForSeconds(0.5)

	--Enter edit mode
	local quarry = fy_QuarryProject.New(Faction.defaultAllied, Markers.GetTagged("project_quarry").position)
	WaitForNextFrame()
	Picking.ResetCommandMode()
	label.Target(quarry)
	label.Offset(Vector3.New(0.0, 5.0, 0.0))
	SetLabel(label, nil, "str_tutorial_quarryproject", nil, nil)
	WaitForCondition(function() return Picking.IsEditMode() end)
	
	--Exit edit mode
	SetLabel(label, nil, "str_tutorial_editmode", nil, nil)
	WaitForCondition(function() return Picking.IsCommandMode() end)

	--Assign to a project
	SetLabel(label, nil, "str_tutorial_assignunit", nil, nil)
	WaitForCondition(function() return quarry.CrewCount() >= 1 end)

	--Good, he will start working
	local stockpile1 = Markers.GetTagged("stockpile_stones_half")
	local stockpile2 = Markers.GetTagged("stockpile_stones_empty")
	SetLabel(label, "str_tutorial_good", "str_tutorial_automaticmining", nil, nil)
	WaitForCondition(function() return stockpile1.RecepteurIsFull() or stockpile2.RecepteurIsFull() end)

	--Yay, you got bricks
	ResetCircle(zone, (stockpile1.RecepteurIsFull() and stockpile1.position or stockpile2.position) + Vector3.New(0.0, 0.5, 0.0), 2)
	label.Target(zone)
	label.Offset(Vector3.New(0.0, 1.0, 0.0))
	SetLabel(label, "str_tutorial_awesome", "str_tutorial_rockstobricks", nil, nil)
	WaitForSeconds(10)
	label.Hide()
	WaitForSeconds(0.5)

	--Now finish the second stockpile
	local stillEmptyStockpile = (stockpile1.RecepteurIsFull() and stockpile2 or stockpile1)
	ResetCircle(zone, stillEmptyStockpile.position + Vector3.New(0.0, 0.5, 0.0), 2)
	SetLabel(label, nil, "str_tutorial_digtwostockpile")
	WaitForCircleCondition(0.5, zone, 
		function() return stillEmptyStockpile.RecepteurIsFull() end)

	--This is a construction task
	local construction = fy_BuildBlocksProject.GetFirst()
	construction.activeSelf = true
	label.Target(construction)
	label.Offset(Vector3.New(0.0, 5.0, 0.0))
	SetLabel(label, nil, "str_tutorial_buildinggroup", nil, nil)
	WaitForCondition(function() return Picking.IsEditMode() end)

	--Assign your bricktron to the construction task
	SetLabel(label, "str_tutorial_blueprints_title", "str_tutorial_blueprints")
	WaitForCondition(function() return construction.CrewCount() >= 1 end)
	label.Hide()

	--Your goal is to get your Bricktron to stand here.
	WaitForCondition(function() return construction.GoalsCount() <= 7 end)
	ResetCircle(zone, Markers.GetTagged("circle_toAct4").position, 1.0)
	label.Target(zone)
	label.Offset(Vector3.New(0.0, 1.0, 0.0))
	SetLabel(label, nil, "str_tutorial_blueprintsintro", nil, nil)
	WaitForCircleCondition(2.0, zone, 
		function() return Physics.CheckCollision(zone, _actors.worker1) end)

	--Great, but let's move the camera up
	MainCamera.canElevate = true
	SetLabel(label, "str_tutorial_great", "str_tutorial_camera_onmorecontrol", nil, nil)
	WaitForSeconds(4)
	label.Hide()
	WaitForSeconds(0.5)

	--Exit to act 4
	--]]
	MainCamera.canElevate = true
	ResetCircle(zone, Markers.GetTagged("circle_toAct4").position, 1.0)
	SetLabel(label, "str_tutorial_camera_pivot_title", "str_tutorial_camera_pivot", nil, nil)
	WaitForCircleCondition(3.0, zone, 
		function() return Physics.ColliderContainsPoint(zone, MainCamera.targetLocation) end)

	--end
	WaitForSeconds(0.5)
	Destroy(label);
	Destroy(zone);
	include "BasicTutorial/Act4.lua"

end
cor_tutorial = coroutine.create(Act3)
