
cor_tutorial = coroutine.create(function()
	--Let's learn complex task
	local label = TooltipBuilder.New()
		.Target(_actors.worker1)
		.Offset( Vector3.New(0.0, 1.0, 0.0))
		.Title("str_tutorial_placingblueprint_title")
		.Text("str_tutorial_placingblueprint")
		.AsDynamic().Make()
	label.Show()
	local zone = fy_CircleZone.New(Faction.defaultAllied, Vector3.zero)
	Rules.SetAllowedTasks({TaskType.Construction})
	--[
	WaitForCondition(function() return Picking.IsEditMode() end)

	--place blueprints
	ResetCircle(zone, Markers.GetTagged("circle_repairs").position, 2.0)
	label.Target(zone)
	SetLabel(label, "str_tutorial_good", "str_tutorial_blueprint_picker", nil, nil)
	WaitForCircleCondition(1.0, zone, 
		function() return BlueprintPresentAt(Markers.GetTagged("repair1").position) and BlueprintPresentAt(Markers.GetTagged("repair2").position) and BlueprintPresentAt(Markers.GetTagged("repair3").position) and BlueprintPresentAt(Markers.GetTagged("repair4").position) and BlueprintPresentAt(Markers.GetTagged("repair5").position) and BlueprintPresentAt(Markers.GetTagged("repair6").position) end)
	
	--Get out of edit mode
	SetLabel(label, "str_tutorial_verynice", "str_tutorial_exit_edit_mode", nil, nil)
	WaitForCondition(function() return Picking.IsCommandMode() end)
	
	--Assign your worker
	label.Target(_actors.worker1)
	SetLabel(label, nil, "str_tutorial_assign_construction")
	local construction = fy_BuildBlocksProject.GetLast()
	WaitForCondition(function() return construction.CrewCount() >= 1 end)
	
	--Wait until the wall is patched
	label.Hide()
	ResetCircle(zone, Markers.GetTagged("circle_repairs").position, 2.0)
	WaitForCircleCondition(1.0, zone, 
		function() return BlockPresentAt(Markers.GetTagged("repair1").position) and BlockPresentAt(Markers.GetTagged("repair2").position) and BlockPresentAt(Markers.GetTagged("repair3").position) and BlockPresentAt(Markers.GetTagged("repair4").position) and BlockPresentAt(Markers.GetTagged("repair5").position) and BlockPresentAt(Markers.GetTagged("repair6").position) end)
	
	--GJ you patched the wall
	SetLabel(label, "str_tutorial_congrats", "str_tutorial_finished_patching", nil, nil)
	WaitForSeconds(2)
	label.Hide()
	WaitForSeconds(0.5)
	
	--Go to act 5
	--]]
	local door = Markers.GetTagged("door_act4to5")
	door.locked = false
	door.Open()
	ResetCircle(zone, Markers.GetTagged("circle_toAct5").position, 2.0)
	label.Target(zone)
	SetLabel(label, nil, "str_tutorial_movenextzone", nil, nil)
	WaitForCircleCondition(1, zone, 
		function() return Physics.ColliderContainsPoint(zone, MainCamera.targetLocation) and Physics.CheckCollision(zone, _actors.worker1) end)
	
	--end
	door.Close()
	door.locked = true
	WaitForSeconds(0.5)
	DisplayOkDialog("str_tutorial_titlethatsall", 
						"str_tutorial_thanksforplaying", 
						"str_tutorial_returntotitlescreen",
						function() Hooks.Invoke(hk_CallEndGame) end)
end)
