--Globals
_actors = {}

function OnLevelReady()
	include "BasicTutorial/Act1.lua"
end
Hooks.Connect(hk_OnLevelReady, OnLevelReady)

function Update()
	RunCoroutine(cor_tutorial)
end
Hooks.Connect(hk_Update, Update)

function RunCoroutine(cor)
	if cor == nil then
		error("Coroutine is nil")
	elseif coroutine.status(cor) ~= "dead" then
		local success, errorMessage = coroutine.resume(cor)
		if not success then
			error("Error in coroutine: "..errorMessage)
		end
	end
end

function WaitForCircleCondition(time, circle, condition)
	WaitForCondition(function()
		if condition() then
			local timer = Timer.New(time)
			timer.Start()
			while condition() do
				coroutine.yield()
				circle.SetProgress(timer.PercentDone())
				if timer.Check() then
					circle.Flash()
					circle.Disappear()
					return true
				end
			end
		else
			circle.SetProgress(0.0)
			return false
		end
	end)
end

function SetLabel(label, title, text, titleImage, image)
	label.Title(title)
	label.Text(text)
	label.TitleImage(titleImage)
	label.Image(image)
	label.Show()
end

function ResetCircle(circle, position, radius)
	if position ~= nil then
		circle.position = position
	end
	circle.SetRadius(radius)
	circle.SetProgress(0.0)
	circle.Appear()
end