define "STANDALONE"

function AddButton(button, target)
	
	button.showBackgroundByDefault = true
	target.AddElement(button)

	if target == GS_TopCorner.Main then
		
		button.anchorMax = Vector2.New(0.5, 0.5)
		button.anchorMin = Vector2.New(0.5, 0.5)
		button.sizeDelta = Vector2.New(65, 64)
		button.anchoredPosition = Vector2.zero

	end

end 

function Init()

	AddButton(lui_UniversalButton.NewButton("MainMenu", 
		IconKeys.UI_Home.Get64(), 
		function() MenuCalls.ToggleMainMenu() end, 
		Color.yellow, 
		"str_top_menu_main_menu"), GS_TopCorner.Main)

	if not IsMultiplayer() and not IsWorldEditor() then

		AddButton(lui_UniversalButton.NewButton("Pause", 
			IconKeys.UI_Pause.Get64(), 
			function() MenuCalls.TogglePause() end, 
			Color.yellow, 
			"str_top_menu_pause"), GS_TopCorner.List)

		AddButton(lui_UniversalButton.NewButton("QuickSave", 
			IconKeys.UI_Quicksave.Get64(), 
			function() MenuCalls.QuickSave() end, 
			Color.yellow, 
			"str_top_menu_quicksave"), GS_TopCorner.List)

	end

	AddButton(lui_UniversalButton.NewButton("ScreenShot", 
		IconKeys.UI_Screenshot.Get64(), 
		function() MenuCalls.TakeScreenShot() end, 
		Color.yellow, 
		"str_top_menu_screenshoot"), GS_TopCorner.List)
	
	AddButton(lui_UniversalButton.NewButton("Mute", 
		IconKeys.UI_Mute.Get64(), 
		function() Sound.mute = not Sound.mute end, 
		Color.yellow, 
		"str_top_menu_mute"), GS_TopCorner.List)

	AddButton(lui_UniversalButton.NewButton("SliceMode", 
		IconKeys.UI_XRay.Get64(), 
		function() MenuCalls.ToggleXRay(XRayObject) end, 
		Color.yellow, 
		"str_top_menu_xray"), GS_TopCorner.List)

	if IsBuildDebug() then

		AddButton(lui_UniversalButton.NewButton("SendToWorkshop", 
			IconKeys.UI_Workshop.Get64(), 
			function() MenuCalls.SendToWorkshop() end, 
			Color.yellow, 
			"Send to workshop"), GS_TopCorner.List)

		AddButton(lui_UniversalButton.NewButton("FogOfWar", 
			IconKeys.UI_FogOfWar.Get64(), 
			function() MenuCalls.ToggleFogOfWar() end, 
			Color.yellow, 
			"str_top_menu_fog_of_war"), GS_TopCorner.List)

		AddButton(lui_UniversalButton.NewButton("Debug", 
			IconKeys.UI_Console.Get64(), 
			function() MenuCalls.ToggleDebugs() end, 
			Color.yellow, 
			"str_top_menu_toggle_debug"), GS_TopCorner.List)

	end

end
Hooks.LateConnect(hk_OnFactoriesReady, Init)

