
function WaitForSeconds (time)
	local co = coroutine.running()
	assert(co ~= nil, "WaitForSeconds must be called from a coroutine")
	
	local t = Timer.New(time)
	t.Start()
	while true do
		if t.Check() then
			return
		else
			coroutine.yield(co)
		end
	end
end

function WaitForCondition(func)
	local co = coroutine.running()
	assert(co ~= nil, "WaitForCondition must be called from a coroutine")

	while true do
		if func() then
			return
		else
			coroutine.yield(co)
		end
	end
end

function WaitForNextFrame ()
	local co = coroutine.running()
	assert(co ~= nil, "WaitForNextFrame must be called from a coroutine")

	coroutine.yield(co)
end

function WaitForHook (hook)
	local co = coroutine.running()
	assert(co ~= nil, "WaitForHook must be called from a coroutine")
	local hookCalled = false
	local hookFunction = function() hookCalled = true end
	Hooks.Connect(hook, hookFunction)
	while true do
		if hookCalled then
			Hooks.Disconnect(hook, hookFunction)
			return
		else
			coroutine.yield(co)
		end
	end
end

function WaitForCircle(time, circle)
	error("WaitForCircle(time, circle) doesn't work anymore")
end